/* base_algo.h */
/* Some basic algorithms */
// TODO: convertire in C puro

#ifndef BASE_ALGO_H
#define BASE_ALGO_H

/** Elimina duplicati adiacenti da un vettore 
    vectin e vectout possono coincidere
    Tempo = O(len) */
template <class Type>
int unique(Type *vectin, Type *vectout, int len) {
  register int i,j,j0;
  i = j = 0;
  while (j < len) {
    for (j0 = j; (j+1) < len && vectin[j0] == vectin[j+1]; ++j) ;
    vectout[i++] = vectin[j++];
  }
  return i;
}

/** confronto fra interi */
int int_cmp(const void *a, const void *b) {
  if (*((int *)a) < *((int *)b)) return -1;
  else if (*((int *)a) > *((int *)b)) return +1;
  else return 0;
}

/** Ordina e toglie duplicati da una lista di interi */
int usort(int *vectin, int *vectout, int len) {
  qsort(vectin, len, sizeof(int), int_cmp);
  int nlen = unique(vectin, vectout, len);
  return nlen;
}

#endif