/* Altre funzioni C per le stringhe */

#ifndef _STRING2_H
#define _STRING2_H

#include <stdlib.h>
#include <string.h>
#include <ctype.h>

char *strrev(char *str);

char *strlower(char *str);
char *strupper(char *str);

char *strnstr(char *where, const char *what, int lim);

char *strlstrip(char *str, char spc);
char *strrstrip(char *str, char spc);
char *strstrip(char *str, char spc);

char *strlsstrip(char *str, const char *search);
char *strrsstrip(char *str, const char *search);
char *strsstrip(char *str, const char *search);

char *strdelchr(char *str, char dc);
char *strdelschr(char *str, const char *ds);

char *strsubchr(char *str, char search, char subst);
char *strsubschr(char *str, const char *search, const char *subst);

//TODO: strsubstr
/*
int strsubstr_calc(const char *str, const char *search, const char *subst);
char *strsubstr(const char *str, const char *search, const char *subst);
*/

int strhamdist(const char *str1, const char *str2);
int strlevdist(const char *str1, const char *str2);


#endif   // STRING2_H
